# This is a BitKeeper generated patch for the following project:
# Project Name: Linux kernel tree
# This patch format is intended for GNU patch command version 2.5 or higher.
# This patch includes the following deltas:
#	           ChangeSet	1.1134+1.1069.175.7 -> 1.1135 
#	drivers/scsi/megaraid.c	1.28    -> 1.29   
#	arch/m68k/bvme6000/rtc.c	1.10    -> 1.11   
#	drivers/char/agp/agpgart_be.c	1.58    -> 1.59   
#	drivers/char/mips_rtc.c	1.5     -> 1.6    
#	drivers/sbus/char/rtc.c	1.12    -> 1.13   
#	drivers/char/ds1286.c	1.13    -> 1.14   
#	     kernel/signal.c	1.11    -> 1.12   
#	  drivers/char/rtc.c	1.18    -> 1.19   
#	   drivers/net/tg3.c	1.76    -> 1.77   
#	drivers/char/agp/agp.h	1.26.1.1 -> 1.28   
#	drivers/char/ip27-rtc.c	1.10    -> 1.11   
#	arch/cris/drivers/pcf8563.c	1.7     -> 1.8    
#	drivers/hil/hp_sdc_rtc.c	1.6     -> 1.7    
#	         mm/mremap.c	1.7.1.1 -> 1.9    
#	           mm/mmap.c	1.39    -> 1.40   
#	            Makefile	1.244   -> 1.245  
#	net/irda/irnet/irnet.h	1.15    -> 1.16   
#	drivers/char/efirtc.c	1.11    -> 1.12   
#	net/ipv4/netfilter/ip_fw_compat_masq.c	1.8     -> 1.9    
#	arch/cris/drivers/ds1302.c	1.10    -> 1.11   
#	Documentation/Configure.help	1.195   -> 1.196  
#	drivers/macintosh/rtc.c	1.10    -> 1.11   
#	          fs/inode.c	1.46    -> 1.47   
#	drivers/acorn/char/i2c.c	1.7     -> 1.8    
#	arch/ppc64/kernel/rtc.c	1.7     -> 1.8    
#	arch/m68k/mvme16x/rtc.c	1.8     -> 1.9    
#
diff -Nru a/Documentation/Configure.help b/Documentation/Configure.help
--- a/Documentation/Configure.help	Thu Jan  8 16:34:13 2004
+++ b/Documentation/Configure.help	Thu Jan  8 16:34:13 2004
@@ -27316,16 +27316,11 @@
   will run on any supported IA-64 system.  However, if you configure
   a kernel for your specific system, it will be faster and smaller.
 
-  To find out what type of IA-64 system you have, you may want to
-  check the IA-64 Linux web site at <http://www.linux-ia64.org/>.
-  As of the time of this writing, most hardware is DIG compliant,
-  so the "DIG-compliant" option is usually the right choice.
-
-  HP-simulator   For the HP simulator (<http://software.hp.com/ia64linux/>).
-  HP-zx1	 For HP zx1 Platforms.
-  SN1            For SGI SN1 Platforms.
-  SN2            For SGI SN2 Platforms.
-  DIG-compliant  For DIG ("Developer's Interface Guide") compliant systems.
+  generic        For any supported IA-64 system
+  DIG-compliant  For DIG ("Developer's Interface Guide") compliant systems
+  HP             For HP systems
+  SGI-SN2        For SGI SN2 systems
+  Ski-simulator  For the HP simulator (<http://www.hpl.hp.com/research/linux/ski/>)
 
   If you don't know what to do, choose "generic".
 
diff -Nru a/mm/mmap.c b/mm/mmap.c
--- a/mm/mmap.c	Thu Jan  8 16:34:13 2004
+++ b/mm/mmap.c	Thu Jan  8 16:34:13 2004
@@ -1044,7 +1044,10 @@
 	if (extra)
 		kmem_cache_free(vm_area_cachep, extra);
 
-	free_pgtables(mm, prev, addr, addr+len);
+	if (is_hugepage_addr(addr))
+		hugetlb_free_pgtables(mm, prev, addr, addr+len);
+	else
+		free_pgtables(mm, prev, addr, addr+len);
 
 	return 0;
 }
